#include "stdafx.h"
#include "resource.h"
#include "UnAlz.h"
#include "FindPass.h"
#include "Global.h"


HINSTANCE			hInst;
LRESULT CALLBACK	MainDlgProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	PassDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

LPTSTR	g_szCmdLine = NULL;
CHAR	g_szPass[256];

HICON	g_hIconBig;
HICON	g_hIconSmall;
BOOL	g_bHalt;				// ?

using namespace UNALZ;

const char* TXT_ABOUT = 
	" α׷ .ALZ   ϴ α׷ Դϴ.\r\n\r\n"
	"Ȩ : www.kipple.pe.kr";

#ifndef _MAX_PATH
#   define _MAX_PATH   260 /* max. length of full pathname */
#endif



int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	hInst = hInstance;

	g_hIconBig = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_TZIP));
	g_hIconSmall = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_SMALL));

	//g_szCmdLine = lpCmdLine;
	g_szCmdLine = new TCHAR[_tcslen(lpCmdLine)+1];
	TCHAR* p;
	TCHAR* q;
	p = lpCmdLine;
	q = g_szCmdLine;
	while(*p)
	{
		if(*p!='"')						// ǥ ֱ..
		{
			*q = *p;
			q++;
		}
		p++;
	}
	*q = 0;

/////////////////// ܼ  ///////////////////////////
#ifdef _DEBUG
	AllocConsole();
	freopen( "conin$", "r", stdin );
	freopen( "conout$", "w", stdout );
	freopen( "conout$", "w", stderr );
#endif

	//CUnAlz	unalz;
	//unalz.DigPath("c:\\test/a/b/c\\d\\e.txt");

	DialogBox(hInstance, (LPCTSTR)IDD_MAIN, NULL, (DLGPROC)MainDlgProc);

	delete g_szCmdLine;

/////////////////// ܼ  ///////////////////////////
#ifdef _DEBUG
	FreeConsole(); 
#endif

	return 0;
}


BOOL IsFile(LPCTSTR szPathName)
{
	DWORD dwRet;
	dwRet = GetFileAttributes(szPathName);
	if(dwRet==-1) return FALSE;
	if(dwRet & FILE_ATTRIBUTE_DIRECTORY) return FALSE;
	return TRUE;
}


void CenterWindow(HWND hWnd)
{
	RECT rcTemp1, rcTemp2 ;
	LONG iX, iY, iWidth, iHeight ;

	GetWindowRect(GetDesktopWindow(),&rcTemp1) ;
	GetWindowRect(hWnd,&rcTemp2) ;
	iWidth = rcTemp2.right - rcTemp2.left ;
	iHeight = rcTemp2.bottom - rcTemp2.top ;
	iX = LONG((rcTemp1.right - iWidth) / 2) ;
	iY = LONG((rcTemp1.bottom - iHeight) / 2) ;
	MoveWindow(hWnd,iX,iY,iWidth,iHeight,TRUE) ;
}

void PumpUntilEmpty(HWND hWnd)
{
	MSG msg;
	while(::PeekMessage(&msg, hWnd, 0, 0, PM_REMOVE))
	{
		::TranslateMessage(&msg);
		::DispatchMessage(&msg);
	}
}

BOOL ExtractResource(LPCTSTR sResName, LPCTSTR szDst)
{
	HRSRC		hResInfo;
	HANDLE		hRes;
	int			nBufSize;
	FILE*		fp;
	
	TCHAR		szType[] = _T("BIN");
	TCHAR*		szRes;
	

	fp = _tfopen(szDst, _T("wb"));
	if(fp==NULL) return FALSE;

	
	hResInfo = FindResource(hInst, sResName, szType);
	if (hResInfo == NULL)  { fclose(fp); return FALSE; }
	
	// Load the resource
	hRes = LoadResource(hInst, hResInfo);
	
	// Lock the resource
	szRes = (TCHAR*)LockResource(hRes);

	if (szRes == NULL) { fclose(fp); FreeResource(hRes); return FALSE; }

	nBufSize = SizeofResource(hInst, hResInfo);
	fwrite(szRes, 1, nBufSize, fp);
	UnlockResource(hRes);  
	
	// Free the resource
	FreeResource(hRes);
	fclose(fp);

	return TRUE;
}

TCHAR g_sGetDirectoryDir[MAX_PATH];
static int CALLBACK BrowseCallbackProc(HWND hwnd,UINT msg,LPARAM lp, LPARAM pData)
{
	TCHAR buf[MAX_PATH];
	switch(msg) 
	{
	case BFFM_INITIALIZED: 
		_tcscpy(buf,g_sGetDirectoryDir);
		::SendMessage(hwnd,BFFM_SETSELECTION,TRUE,(LPARAM)buf);
		break;
	case BFFM_SELCHANGED:
		if (::SHGetPathFromIDList((LPITEMIDLIST) lp ,buf)) 
			SendMessage(hwnd,BFFM_SETSTATUSTEXT,0,(LPARAM)buf);
		break;
	}
	return 0;
}

#ifndef BIF_NEWDIALOGSTYLE
  #define BIF_NEWDIALOGSTYLE     0x0040   // Use the new dialog layout with the ability to resize
  #define BIF_USENEWUI           (BIF_NEWDIALOGSTYLE | BIF_EDITBOX)
#endif
LPCTSTR GetDirectory(HWND hWndParent, LPCTSTR szRoot, LPCTSTR szTitle)
{
	static TCHAR str[MAX_PATH];
	BROWSEINFO bi;
    bi.hwndOwner=hWndParent;		//owner of created dialog box
    bi.pidlRoot=0;					//unused
    bi.pszDisplayName=0;			//buffer to receive name displayed by folder (not a valid path)
    bi.lpszTitle=szTitle;			//title is "Browse for Folder", this is an instruction
	bi.lpfn = BrowseCallbackProc;	//callback routine called when dialog has been initialized
    bi.lParam=0;					//passed to callback routine
    bi.ulFlags=
		BIF_RETURNONLYFSDIRS |		//only allow user to select a directory
		BIF_STATUSTEXT |			//create status text field we will be writing to in callback
		BIF_NEWDIALOGSTYLE |		// resizing  ο Ÿ..OleInitialize()  ȣ Ǿ־ ..
//		BIF_BROWSEFORCOMPUTER|		//only allow user to select a computer
//		BIF_BROWSEFORPRINTER |		//only allow user to select a printer
//		BIF_BROWSEINCLUDEFILES|		//displays files too which user can pick
//		BIF_DONTGOBELOWDOMAIN|		//when user is exploring the "Entire Network" they
									// are not allowed into any domain
		0; 
	_tcscpy(g_sGetDirectoryDir, szRoot);

	LPITEMIDLIST lpItemId=::SHBrowseForFolder(&bi); 
	if (lpItemId)
	{
		::SHGetPathFromIDList(lpItemId, str);
		::GlobalFree(lpItemId);
	}

	return str;
}

void SetFileName(HWND hDlg, LPCTSTR szPathName)
{
	SetDlgItemText(hDlg, IDC_EDIT_ALZPATH, szPathName);
	//TCHAR* temp = _tcsrchr(szPathName, '\\');
	TCHAR* temp = _tcsrchr(szPathName, '.');
	
	if(temp)
	{
		*(temp) = '\\';
		*(temp+1) = 0;
		SetDlgItemText(hDlg, IDC_EDIT_OUTPATH, szPathName);
	}
}


#ifndef LVM_SETEXTENDEDLISTVIEWSTYLE
#define LVM_SETEXTENDEDLISTVIEWSTYLE (LVM_FIRST + 54)   // optional wParam == mask
#endif

void SetListControl(HWND hList)
{
	LVCOLUMN	lvcolumn;
	lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	lvcolumn.fmt = LVCFMT_LEFT;
	lvcolumn.iSubItem = 0;

	RECT r;
	::GetWindowRect(hList, &r);
	lvcolumn.cx = 100;
	lvcolumn.pszText = (LPTSTR)_T("޽");

	::SendMessage(hList, LVM_INSERTCOLUMN, 0, (LPARAM)&lvcolumn);
//	::SendMessage(hList, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, (LPARAM) LVS_EX_FULLROWSELECT);
	::SendMessage(hList, LVM_SETCOLUMNWIDTH, 0, (LPARAM)LVSCW_AUTOSIZE_USEHEADER);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
///          list control  ޽ Ѹ
/// @date    2004-03-01  6:12:51
////////////////////////////////////////////////////////////////////////////////////////////////////
#define LEN_MSG	1024
void Message(HWND hList, LPCTSTR str, ...)
{
	TCHAR	msg[LEN_MSG];
	BOOL	bPartialOK = FALSE;
	va_list args;
	va_start(args, str);
	_vstprintf(msg, str, args);
	va_end(args);

	int	nCount = ::SendMessage(hList, LVM_GETITEMCOUNT, 0, 0L);

	LVITEM item;
	item.mask = LVIF_TEXT;
	item.iItem = nCount;
	item.iSubItem = 0;
	item.pszText = (LPTSTR)msg;
	item.state = 0;
	item.stateMask = 0;
	item.iImage = 0;
	item.lParam = 0;

	::SendMessage(hList, LVM_INSERTITEM, 0, (LPARAM)&item);
	::SendMessage(hList, LVM_ENSUREVISIBLE, (LPARAM)nCount,MAKELPARAM(bPartialOK, 0));
	::SendMessage(hList, LVM_SETCOLUMNWIDTH, 0, (LPARAM)LVSCW_AUTOSIZE_USEHEADER);
}

void MakeNumber(INT64 number, CHAR* szBuf, int nBufSize)
{
	CHAR szNumber[MAX_PATH];
	wsprintf(szNumber, _T("%I64d"), number);
	NUMBERFMT fmt = {0, 0, 3, ".", ",", 1};
	
	GetNumberFormat(0, 0, szNumber, &fmt, szBuf, nBufSize);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
///          progress callback param
/// @date    2004-03-01  6:08:35
////////////////////////////////////////////////////////////////////////////////////////////////////
void UnAlzCallback(const char* szMessage, INT64 nCurrent, INT64 nRange, void* param, BOOL* bHalt)
{
	HWND hDlg = (HWND)param;
	HWND	hList = GetDlgItem(hDlg, IDC_LIST_MESSAGE);

	// ϸ ..
	if(szMessage)
	{
		Message(hList, szMessage);
		return ;
	}

#define NUM_LEN 64
	// progress
	TCHAR	buf[1000];
	TCHAR   num1[NUM_LEN], num2[NUM_LEN];
	double	percent;
	static DWORD dwTick = 0;

	percent = nCurrent*100./nRange;

	if(nCurrent!=nRange && GetTickCount()-dwTick<200) return;		// ʹ  Ʈ ..
	dwTick = GetTickCount();


	MakeNumber(nCurrent, num1, NUM_LEN);
	MakeNumber(nRange, num2, NUM_LEN);

	wsprintf(buf, "%s/%s (%d%%)", num1, num2, (int)percent);
	SetDlgItemText(hDlg, IDC_STATIC_PROGRESS, buf);

	PumpUntilEmpty(hDlg);

	if(g_bHalt && bHalt)	*bHalt = TRUE;		//  ..
}

////////////////////////////////////////////////////////////////////////////////////////////////////
///          control enable/disable ϱ
/// @date    2004-03-01  6:34:40
////////////////////////////////////////////////////////////////////////////////////////////////////
static void EnableControl(HWND hDlg, BOOL bExtracting)
{
	BOOL bEnable;
	BOOL bDisable;

	if(bExtracting)
	{
		bEnable = FALSE;
		bDisable = TRUE;
	}
	else
	{
		bEnable = TRUE;
		bDisable = FALSE;
	}
	
	// ҿ enable
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_ALZPATH),	bEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_EDIT_OUTPATH),	bEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_FINDALZ),	bEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_FINDPATH), bEnable);
	EnableWindow(GetDlgItem(hDlg, IDCANCEL),			bEnable);
	EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_EXTRACT),	bEnable);

	// Ǯ enable
	EnableWindow(GetDlgItem(hDlg, IDC_BUTTON_STOP),		bDisable);
}

void AskPassword(HWND hDlg, CUnAlz& unalz)
{
	memset(g_szPass, 0, sizeof(g_szPass));
	DialogBox(hInst, (LPCTSTR)IDD_PASS, hDlg, (DLGPROC)PassDlgProc);
	if(strlen(g_szPass))
		unalz.setPassword(g_szPass);		// ȣ .
}
	

LRESULT CALLBACK MainDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND	hList = GetDlgItem(hDlg, IDC_LIST_MESSAGE);
	switch (message)
	{
	case WM_INITDIALOG:
		::SendMessage(hDlg, WM_SETICON, TRUE, (LPARAM)g_hIconBig);
		::SendMessage(hDlg, WM_SETICON, FALSE, (LPARAM)g_hIconSmall);
		CenterWindow(hDlg);
		DragAcceptFiles(hDlg, TRUE);

		if(g_szCmdLine && _tcslen(g_szCmdLine))
			SetFileName(hDlg, g_szCmdLine);

		SetListControl(hList);
		EnableControl(hDlg, FALSE);

		return TRUE;
		
	case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
			case IDC_BUTTON_EXTRACT :
				{
					TCHAR szSrc[MAX_PATH];
					TCHAR szDst[MAX_PATH];
					BOOL  ret;

					GetDlgItemText(hDlg, IDC_EDIT_ALZPATH, szSrc, MAX_PATH);
					GetDlgItemText(hDlg, IDC_EDIT_OUTPATH, szDst, MAX_PATH);

					if(::IsFile(szSrc)==FALSE)
					{
						MessageBox(hDlg, _T(".ALZ  ΰ ٸ ʽϴ."), APP, MB_OK);
						return 0;
					}

					if(CUnAlz::IsFolder(szDst)==FALSE)
					{
						CUnAlz::DigPath(szDst);					//   ..
					}

					if(CUnAlz::IsFolder(szDst)==FALSE)
					{
						MessageBox(hDlg, _T("  ΰ ٸ ʽϴ."), APP, MB_OK);
						return 0;
					}

					CUnAlz	unalz;
					if(unalz.Open(szSrc)==FALSE)
					{
						if(unalz.GetLastErr()==CUnAlz::ERR_CORRUPTED_FILE)
						{
							MessageBox(hDlg, _T("ջ ̹Ƿ   ջǾ  ֽϴ."), APP, MB_OK);
						}
						else
							MessageBox(hDlg, _T("ALZ  ƴϰų ջǾ      Դϴ."), APP, MB_OK);
						//return 0;
					}

					if(unalz.IsEncrypted())
					{
						AskPassword(hDlg, unalz);
					}

					// callback Լ 
					unalz.SetCallback(UnAlzCallback, (void*)hDlg);
					g_bHalt = FALSE;

					DWORD dwStart = ::GetTickCount();
					TCHAR buf[1024];
					Message(hList, " Ǯ ");
					EnableControl(hDlg, TRUE);

					//    Ǭ..
					//unalz.ExtractAll(szDst);
					CUnAlz::FileList::iterator	i;
					CUnAlz::FileList fileList = unalz.GetFileList();

					for(i=fileList.begin(); i<fileList.end(); i++)		//   鼭
					{
						unalz.SetCurrentFile(i);
						ret = unalz.ExtractCurrentFile(szDst);
						if(ret==FALSE)		//  Ǯ..
						{
							if(unalz.GetLastErr()==CUnAlz::ERR_PASSWD_NOT_SET || unalz.GetLastErr()==CUnAlz::ERR_INVALID_PASSWD) // ȣ  .
							{
								AskPassword(hDlg, unalz);
								unalz.SetCurrentFile(i);
								ret = unalz.ExtractCurrentFile(szDst);	//  ȣ ٽ ѹ  Ǯ..
							}
						}
						if(ret==FALSE)
						{
							sprintf(buf, "  ߻ : %s(Code:%d)", unalz.GetLastErrStr(), unalz.GetLastErr());
							Message(hList, buf);
						}
						if(g_bHalt) break;							// ߱..
					}

					sprintf(buf, " Ǯ  : %.1f", (GetTickCount()-dwStart)/1000.);
					Message(hList, buf);
					EnableControl(hDlg, FALSE);

					return 0;
				}
				break;


			case IDC_BUTTON_FINDALZ :
				{
					TCHAR* szFile;
					OPENFILENAME ofn;       
					szFile = (TCHAR*)calloc(sizeof(TCHAR), MAX_PATH*2);

					// Initialize OPENFILENAME
					ZeroMemory(&ofn, sizeof(OPENFILENAME));
					ofn.lStructSize = sizeof(OPENFILENAME);
					ofn.hwndOwner = hDlg;
					ofn.lpstrFile = szFile;
					ofn.nMaxFile = MAX_PATH;
					ofn.lpstrFilter = _T("alz\0*.alz\0\0*.*\0\0");
					ofn.nFilterIndex = 1;
					ofn.lpstrFileTitle = NULL;
					ofn.nMaxFileTitle = 0;
					ofn.lpstrTitle = _T(" ");
					ofn.lpstrInitialDir = NULL;
					ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;

					if (!GetOpenFileName (&ofn)) { free(szFile); return 0; }


					SetFileName(hDlg, szFile);

					free(szFile);
				}
				return 0;

			case IDC_OPEN_FOLDER :
				{
					TCHAR szPath[MAX_PATH];
					GetDlgItemText(hDlg, IDC_EDIT_OUTPATH, szPath, MAX_PATH);
					ShellExecute(NULL, _T("open"), szPath, NULL, NULL, SW_SHOW);
				}
				return 0;

			case IDC_BUTTON_STOP :
				g_bHalt = TRUE;
				return 0;

			case IDC_BUTTON_FINDPATH :
				{
					TCHAR szPath[MAX_PATH];
					GetDlgItemText(hDlg, IDC_EDIT_OUTPATH, szPath, MAX_PATH);

					LPCTSTR szPath2 = GetDirectory(hDlg, szPath, _T("Ǯ  "));
					if(_tcslen(szPath2)==0) return 0;
					SetDlgItemText(hDlg, IDC_EDIT_OUTPATH, szPath2);
					return 0;
				}

			case IDC_BUTTON_ABOUT :
				MessageBox(hDlg, TXT_ABOUT, APP, MB_OK|MB_ICONEXCLAMATION);
				return 0;

			case IDC_BUTTON_FIND_PASS :			// Find Password
				{
					TCHAR szSrc[MAX_PATH];
					GetDlgItemText(hDlg, IDC_EDIT_ALZPATH, szSrc, MAX_PATH);
					DoFindPassword(hInst, hDlg, szSrc);
					return 0;
				}


			case IDOK :
			case IDCANCEL :
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
		}
		break;

	case WM_DROPFILES :
		{
			HDROP			hDropInfo = (HDROP) wParam; 
			TCHAR			szPathName[_MAX_PATH];
			int				nCount;

			nCount = ::DragQueryFile(hDropInfo, 0xffffffff, NULL, 0);

			::DragQueryFile(hDropInfo, 0, szPathName, _MAX_PATH);

			SetFileName(hDlg, szPathName);
			::DragFinish(hDropInfo);

		}
		break;

	}
    return FALSE;
}


LRESULT CALLBACK PassDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		CenterWindow(hDlg);
		return TRUE;
	case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
			case IDOK :
				GetDlgItemText(hDlg, IDC_EDIT_PASS, g_szPass, 256);
			case IDCANCEL :
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
		}
		break;
	}

	return FALSE;
}
